@building-option +create-set-co
@create $utils named crypto utilities:crypto utilities,crypto_utils
;_.("aliases") = {"crypto utilities", "crypto_utils"}
;_.("unique") = 0

@verb _:"sha1" this none this
@program _:sha1
{data} = args;
"Pure MOO code implementation of SHA-1.";
":sha1(data) => hex-encoded SHA1 of data";
al = {17, 18, 19, 20};
bl = {21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40};
cl = {41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60};
dl = {61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80};
aa = 1732584193.0;
bb = 4023233417.0;
cc = 2562383102.0;
dd = 271733878.0;
ee = 3285377520.0;
a = b = c = d = e = t = 0.0;
r = p = l = 0;
if (typeof(data) == STR)
  data = $string_utils:explode(data, "");
  for x in [1..length(data)]
    data[x] = $string_utils:character_to_ascii(data[x]);
  endfor
endif
loop = 1;
while (loop)
  buffer = data[l + 1..min(64 + l, length(data))];
  l = l + (r = length(buffer));
  if ((r < 64) && (!p))
    p = 1;
    r = r + 1;
    buffer = {@buffer, 128};
  endif
  W = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
  unpack = {@buffer, 0, 0, 0, 0, 0, 0, 0};
  i = 1;
  while ((length(unpack) > 4) && (i <= 16))
    W[i] = tofloat(((this:shift(unpack[1], 24) + this:shift(unpack[2], 16)) + this:shift(unpack[3], 8)) + unpack[4]);
    unpack = unpack[5..$];
    i = i + 1;
  endwhile
  if (r < 57)
    W[16] = tofloat(l * 8);
  endif
  a = aa;
  b = bb;
  c = cc;
  d = dd;
  e = ee;
  for number in (W)
    t = ((((this:flXOR(this:flAND(b, this:flXOR(c, d)), d) + e) + number) + 1518500249.0) + this:flOR(this:shift(a, 5), this:flAND(31.0, this:shift(a, -27)))) % 4294967296.0;
    e = d;
    d = c;
    c = this:flOR(this:shift(b, 30), this:flAND(1073741823.0, this:shift(b, -2))) % 4294967296.0;
    b = a;
    a = t;
  endfor
  W = {@W, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
  for number in (al)
    t = this:flXOR(this:flXOR(this:flXOR(W[number - 3], W[number - 8]), W[number - 14]), W[number - 16]);
    W[number] = t = this:flOR(this:shift(t, 1), this:flAND(1.0, this:shift(t, -31)));
    t = ((((t + this:flXOR(this:flAND(b, this:flXOR(c, d)), d)) + e) + 1518500249.0) + this:flOR(this:shift(a, 5), this:flAND(31.0, this:shift(a, -27)))) % 4294967296.0;
    e = d;
    d = c;
    c = this:flOR(this:shift(b, 30), this:flAND(1073741823.0, this:shift(b, -2))) % 4294967296.0;
    b = a;
    a = t;
  endfor
  suspend(0);
  for number in (bl)
    t = this:flXOR(this:flXOR(this:flXOR(W[number - 3], W[number - 8]), W[number - 14]), W[number - 16]);
    W[number] = t = this:flOR(this:shift(t, 1), this:flAND(1.0, this:shift(t, -31)));
    t = ((((t + this:flXOR(b, this:flXOR(c, d))) + e) + 1859775393.0) + this:flOR(this:shift(a, 5), this:flAND(31.0, this:shift(a, -27)))) % 4294967296.0;
    e = d;
    d = c;
    c = this:flOR(this:shift(b, 30), this:flAND(1073741823.0, this:shift(b, -2))) % 4294967296.0;
    b = a;
    a = t;
  endfor
  suspend(0);
  for number in (cl)
    t = this:flXOR(this:flXOR(this:flXOR(W[number - 3], W[number - 8]), W[number - 14]), W[number - 16]);
    W[number] = t = this:flOR(this:shift(t, 1), this:flAND(1.0, this:shift(t, -31)));
    t = ((((t + this:flOR(this:flAND(b, c), this:flAND(this:flOR(b, c), d))) + e) + 2400959708.0) + this:flOR(this:shift(a, 5), this:flAND(31.0, this:shift(a, -27)))) % 4294967296.0;
    e = d;
    d = c;
    c = this:flOR(this:shift(b, 30), this:flAND(1073741823.0, this:shift(b, -2))) % 4294967296.0;
    b = a;
    a = t;
  endfor
  for number in (dl)
    t = this:flXOR(this:flXOR(this:flXOR(W[number - 3], W[number - 8]), W[number - 14]), W[number - 16]);
    W[number] = t = this:flOR(this:shift(t, 1), this:flAND(1.0, this:shift(t, -31)));
    t = ((((t + this:flXOR(this:flXOR(b, c), d)) + e) + 3395469782.0) + this:flOR(this:shift(a, 5), this:flAND(31.0, this:shift(a, -27)))) % 4294967296.0;
    e = d;
    d = c;
    c = this:flOR(this:shift(b, 30), this:flAND(1073741823.0, this:shift(b, -2))) % 4294967296.0;
    b = a;
    a = t;
  endfor
  suspend(0);
  aa = aa + a;
  bb = bb + b;
  cc = cc + c;
  dd = dd + d;
  ee = ee + e;
  if (r <= 56)
    loop = 0;
  endif
endwhile
aa = aa % 4294967296.0;
bb = bb % 4294967296.0;
cc = cc % 4294967296.0;
dd = dd % 4294967296.0;
ee = ee % 4294967296.0;
return tostr(this:floatToHex(aa), this:floatToHex(bb), this:floatToHex(cc), this:floatToHex(dd), this:floatToHex(ee));
.

@verb _:"flXOR" this none this
@program _:flXOR
bl1 = this:BLFromFloat(tofloat(args[1]));
bl2 = this:BLFromFloat(tofloat(args[2]));
blOut = {};
for x in [1..32]
  blOut = {@blOut, bl1[x] != bl2[x]};
endfor
return this:FloatFromBL(blOut);
.

@verb _:"flOR" this none this
@program _:flOR
bl1 = this:BLFromFloat(tofloat(args[1]));
bl2 = this:BLFromFloat(tofloat(args[2]));
blOut = {};
for i in [1..32]
  blOut = {@blOut, bl1[i] || bl2[i]};
endfor
return this:FloatFromBL(blOut);
"Copied from math utilities (#26):OR by Kenny (#267) Mon Apr 19 13:20:39 2004 PDT";
.

@verb _:"flAND" this none this
@program _:flAND
bl1 = this:BLFromFloat(tofloat(args[1]));
bl2 = this:BLFromFloat(tofloat(args[2]));
blOut = {};
for i in [1..32]
  blOut = {@blOut, bl1[i] && bl2[i]};
endfor
return this:FloatFromBL(blOut);
"Copied from math utilities (#26):AND by Kenny (#267) Mon Apr 19 13:19:23 2004 PDT";
.

@verb _:"floatToHex" this none this
@program _:floatToHex
{number} = args;
hex = "0123456789abcdef";
hexstring = "";
for x in [1..8]
  c = toint(number % 16.0);
  hexstring = hex[c + 1] + hexstring;
  number = number / 16.0;
endfor
return hexstring;
.

@verb _:"shift" this none this
@program _:shift
{number, shift} = args;
shifted = (tofloat(number) * (2.0 ^ tofloat(shift))) % 4294967296.0;
if (typeof(number) == INT)
  if (shifted > tofloat($maxint))
    shifted = tofloat($minint);
  endif
  return toint(shifted);
else
  return floor(shifted);
endif
.

@verb _:"BLFromFloat" this none this
@program _:BLFromFloat
x = args[1];
l = {};
for i in [1..32]
  l = {abs(toint(x % 2.0)), @l};
  x = floor(x / 2.0);
endfor
return l;
.

@verb _:"FloatFromBL" this none this
@program _:FloatFromBL
bl = args[1];
x = 0.0;
for l in (bl)
  x = x * 2.0;
  x = x + tofloat(l);
endfor
return x;
.

@verb _:"IntFromBL" this none this
@program _:IntFromBL
bl = args[1];
x = 0;
sign = bl[1];
for l in (listdelete(bl, 1))
  x = x * 2;
  x = x + l;
endfor
if (sign)
  x = $minint + x;
endif
return x;
.

@verb _:"BLFromInt" this none this
@program _:BLFromInt
x = args[1];
firstbit = 0;
if (x < 0)
  firstbit = 1;
  x = $minint + x;
endif
l = {};
for i in [1..31]
  l = {x % 2, @l};
  x = x / 2;
endfor
return {firstbit, @l};
.

@verb _:"XOR" this none this
@program _:XOR
bl1 = this:BLFromInt(args[1]);
bl2 = this:BLFromInt(args[2]);
blOut = {};
for x in [1..32]
  blOut = {@blOut, bl1[x] != bl2[x]};
endfor
return this:IntFromBL(blOut);
.

@verb _:"OR" this none this
@program _:OR
bl1 = this:BLFromInt(args[1]);
bl2 = this:BLFromInt(args[2]);
blOut = {};
for i in [1..32]
  blOut = {@blOut, bl1[i] || bl2[i]};
endfor
return this:IntFromBL(blOut);
.

@verb _:"AND" this none this
@program _:AND
bl1 = this:BLFromInt(args[1]);
bl2 = this:BLFromInt(args[2]);
blOut = {};
for i in [1..32]
  blOut = {@blOut, bl1[i] && bl2[i]};
endfor
return this:IntFromBL(blOut);
.

@verb _:"intToHex" this none this
@program _:intToHex
{number} = args;
hex = "0123456789abcdef";
hexstring = "";
addAtEnd = 0;
if (number < 0)
  number = $minint + number;
  addAtEnd = 8;
endif
for x in [1..7]
  c = number % 16;
  hexstring = hex[c + 1] + hexstring;
  number = number / 16;
endfor
c = number + addAtEnd;
hexstring = hex[c + 1] + hexstring;
return hexstring;
.

"***finished***
