@building-option +create-set-co
@create #1900 named XMPP dialback:XMPP dialback,Jabber dialback,dialback,jdialback
@prop _."stanza" "db" rc
@prop _.":subtype" "" ""
@prop _.":id" "" ""
@prop _.":type" "" ""
@prop _.":connection" #-1 ""
@prop _.":text" "" ""
@prop _.":connection_level" 1 ""
@prop _.":original_source" #-1 ""
;_.(":tries") = 1
;_.("aliases") = {"XMPP dialback", "Jabber dialback", "dialback", "jdialback"}

@verb _:":handle_result" this none this
@program _::handle_result
{connection, attributes, text, children} = args;
validity = -1;
for attribute in (attributes)
  {key, value} = attribute;
  if (key == "from")
    remote_server = value;
    if (!connection.stream.to)
      connection.stream.to = remote_server;
    endif
  elseif (key == "to")
    local_server = value;
  elseif (key == "type")
    validity = value == "valid";
  endif
endfor
if (validity >= 0)
  connection.stream:set_connected(2);
elseif (text)
  dbv = $local.jabber:new_type_handler("db:verify");
  dbv.connection_level = 1;
  dbv.subtype = "verify";
  dbv.to = remote_server;
  dbv.from = local_server;
  dbv.id = connection.stream.id;
  dbv.text = text;
  $local.jabber:send(dbv);
else
  raise(E_INVARG, "Okay, I guess we're not friends, then.");
endif
.

@verb _:":handle" this none this
@program _::handle
{connection, type, attributes, text, children} = args;
this.original_source = connection;
subtype = type[index(type, ":") + 1..$];
this.subtype = subtype;
success = this:(tostr("handle_", subtype))(connection, attributes, text, children);
return success;
.

@verb _:":set_subtype" this none this
@program _::set_subtype
{subtype} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if ((subtype == "result") || (subtype == "verify"))
  return this.subtype = subtype;
else
  raise(E_INVARG, "subtype must be 'result' or 'verify'");
endif
.

@verb _:":serialize" this none this
@program _::serialize
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if ((!this.from) && valid(this.connection))
  this.from = this.connection.stream.from;
endif
xml = {tostr(this.class.stanza, ":", this.subtype), {{"to", this.to}, {"from", this.from}}, this.text ? this.text | "", {}};
this.id && (xml[2] = {@xml[2], {"id", this.id}});
this.type && (xml[2] = {@xml[2], {"type", this.type}});
return $local.xml:xml_unparse(@xml);
.

@verb _:":handle_verify" this none this
@program _::handle_verify
{connection, attributes, text, children} = args;
validity = -1;
for attribute in (attributes)
  {key, value} = attribute;
  if (key == "from")
    remote_server = value;
  elseif (key == "to")
    local_server = value;
  elseif (key == "id")
    id = value;
  elseif (key == "type")
    validity = value == "valid";
  endif
endfor
if (validity >= 0)
  conn = $local.jabber:find_connection_by_id(id);
  if (!valid(conn))
    "our connection has gone away.";
    return;
    "raise(E_INVIND, \"I think you have the wrong person.\");";
  endif
  "We have received a reply. Tell the initial connection we're good to go.";
  dbr = $local.jabber:new_type_handler("db");
  dbr.subtype = "result";
  dbr.to = remote_server;
  dbr.from = local_server;
  dbr.id = id;
  if (validity)
    dbr.type = "valid";
  endif
  conn:send(dbr);
  conn.stream:set_connected(2);
else
  "This must be an initiating request in response to an outbound connection";
  dbv = $local.jabber:new_type_handler("db");
  dbv.subtype = "verify";
  dbv.to = remote_server;
  dbv.from = local_server;
  dbv.id = id;
  dbv.type = "invalid";
  conn = $local.jabber:find_connection_by_dialback(text);
  if (valid(conn))
    dbr = conn:get_type_handler("db:result");
    if (dbr.text == text)
      dbv.type = "valid";
      connection.stream:set_connected(2);
    endif
  endif
  connection:send(dbv);
endif
.

"***finished***
